import { enterWith } from '../../support/cypress.util';

export class StatistikFieldsFormE2EComponent {
  private readonly formEngineInput: string = 'form-engine-name-text-input';
  private readonly formIdInput: string = 'form-id-text-input';
  private readonly formDataFieldInput: string = 'mapping-field-';
  private readonly addDataFieldButton: string = 'add-mapping-button';
  private readonly deleteDataFieldButtonPrefix: string = 'remove-mapping-button-';
  private readonly saveButton: string = 'save-button';
  private readonly cancelButton: string = 'cancel-button';

  public getFormEngineInput(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.formEngineInput);
  }

  public enterFormEngine(text: string): void {
    enterWith(this.getFormEngineInput(), text);
  }

  public getFormIdInput(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.formIdInput);
  }

  public enterFormId(text: string): void {
    enterWith(this.getFormIdInput(), text);
  }

  public getAddFieldButton(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.addDataFieldButton);
  }

  public addField(): void {
    this.getAddFieldButton().click();
  }

  public getDataFieldInput(index: number): Cypress.Chainable<Element> {
    return cy.getTestElement(this.formDataFieldInput + index + '-text-input');
  }

  public enterDataFieldPath(text: string, index: number): void {
    enterWith(this.getDataFieldInput(index), text);
  }

  public getDataFieldDeleteButton(index: number): Cypress.Chainable<Element> {
    return cy.getTestElement(this.deleteDataFieldButtonPrefix + index);
  }

  public deleteDataField(index: number): void {
    this.getDataFieldDeleteButton(index).click();
  }

  public getSaveButton(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.saveButton);
  }

  public save(): void {
    this.getSaveButton().click();
  }

  public getCancelButton(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.cancelButton);
  }

  public cancel(): void {
    this.getCancelButton().click();
  }
}
